/* Copyright 2016 Dirk Duschinger */

//////////////////////////////////////
// author : Dirk Duschinger         //
// email  : dirk.duschigner@cern.ch //
//////////////////////////////////////

#ifndef INCLUDE_EPSCOMMANDS_H_
#define INCLUDE_EPSCOMMANDS_H_

#include <list>
#include <string>
#include <vector>

#include "EpsObject.h"
#include "EpsPolygon.h"

class EpsCommands {
 public:
  EpsCommands();
  EpsCommands(std::string com,
              std::vector<EpsPolygon*>* ListOfObjects,
              std::list<std::string>* sStack,
              std::vector<double>* dStack);
  virtual ~EpsCommands();

 protected:
  void Show(std::vector<EpsPolygon*>* ListOfObjects,
            std::list<std::string>* sStack,
            std::vector<double>* dStack);
  void Neg(std::vector<double>* dStack);
  void Exch(std::vector<double>* dStack);
  void Dup(std::vector<double>* dStack);
  void MoveTo(std::vector<EpsPolygon*>* ListOfObjects,
              std::vector<double>* dStack);
  void RLineTo(std::vector<EpsPolygon*>* ListOfObjects,
               std::vector<double>* dStack);
  void ClosePath(std::vector<EpsPolygon*>* ListOfObjects);
  void SetRGBColor(std::vector<EpsPolygon*>* ListOfObjects,
                   std::vector<double>* dStack);
  void SetGray(std::vector<EpsPolygon*>* ListOfObjects,
               std::vector<double>* dStack);
  void Stroke(std::vector<EpsPolygon*>* ListOfObjects);
  void EOFill(std::vector<EpsPolygon*>* ListOfObjects);
};

#endif  // INCLUDE_EPSCOMMANDS_H_
