/* Copyright 2016 Dirk Duschinger */

//////////////////////////////////////
// author : Dirk Duschinger         //
// email  : dirk.duschigner@cern.ch //
//////////////////////////////////////

#ifndef INCLUDE_ROOTPANELENTRY_H_
#define INCLUDE_ROOTPANELENTRY_H_

#include <string>
#include <vector>
#include <iostream>

#include "TObject.h"

class ROOTPanelEntry {
 public:
  ROOTPanelEntry();
  ~ROOTPanelEntry();

  void AddChild(ROOTPanelEntry* child);

  ROOTPanelEntry* GetChild(size_t i);
  std::vector<ROOTPanelEntry*> GetChildren();
  int GetColor();
  bool GetFold();
  TObject* GetObject();
  ROOTPanelEntry* GetParent();
  std::string GetName();

  bool GetIsFolder();
  void SetColor(int color);
  void SetFold(bool fold);
  void SetIsFolder(bool isfolder);
  void SetObject(TObject* obj);
  void SetParent(ROOTPanelEntry* parent);
  void SetName(std::string name);

  void ToggleFold();

 private:
  std::vector<ROOTPanelEntry*> m_vChildren;
  ROOTPanelEntry* m_Parent;
  std::string m_Name;
  bool m_bFold;
  bool m_bIsFolder;
  int m_iColor;
  TObject* m_oObj = NULL;
};

std::ostream& operator<<(std::ostream& os, ROOTPanelEntry& rpe);

#endif  // INCLUDE_ROOTPANELENTRY_H_
